#include "compiler.h"
#include "ctkparser.h"

static CtkArray* _args_ = 0;

int main(int argc, char* argv[])
{
    if (argc == 1) { 
		printf("C-Talk intergreter version 1.19\n\n");
		printf("Usage: ctalk module [arg1 arg2 ...]\n\n");
		printf("module is a ctalk file name with extension omitted.\n");
		return 1;
    }

    _args_ = ctkCreateArray();

    for (int i = 0; i < argc; i++) {
		CtkObject key;
		CtkObject value;
		MAKE_INTEGER(key, i);
		MAKE_STRING(value, argv[i]);
		ctkPutArray(_args_, key, value);
	}

    CtkCompiler::instance.path = new CtkPath(".", NULL);
    CtkCompiler::instance.path = new CtkPath(".\\test", CtkCompiler::instance.path);
    CtkCompiler::instance.path = new CtkPath(".\\ctk", CtkCompiler::instance.path);
    CtkCompiler::instance.path = new CtkPath(".\\lib", CtkCompiler::instance.path);

	if (CtkCompiler::instance.compile(CtkSymbolTable::instance.add(argv[1], IDENT)) == NULL) { 
		fprintf(stdout, "Failed to locate module \"%s.ctk\"\n", argv[1]);
		return 1;
	}

    return 0;
}


static CtkObject GetArgs(int nArgs, CtkObject* args) {
    if (nArgs > 0) return ctkGetArray(_args_, args[0]);
	return ctkNull;
}
static CtkPrimitive main1("args", GetArgs);
