#ifndef __ZE_MATH_H__
#define __ZE_MATH_H__

#ifdef ZE_EXPORTS
	#define ZE_API __declspec(dllexport)
#elif ZE_IMPORTS 
	#define ZE_API __declspec(dllimport)
#else
	#define ZE_API
#endif

#ifdef __cplusplus
extern "C" {
#endif


ZE_API
int amath_cal2jul(int yy, int mm, int dd);

ZE_API
double amath_jul2cal(int *yy, int *mm, int *dd, double jul);

ZE_API
int amath_jul2tim(int *hh, int *mn, int *sc, double jul);

ZE_API
int amath_make_julian(void *ptr, size_t n, int ds, int yy, int mm, int dd, int hh, int mn, int sc);

ZE_API
int amath_cos(void *ptr);

ZE_API
int amath_acos(void *ptr);

ZE_API
int amath_cosh(void *ptr);

ZE_API
int amath_sin(void *ptr);

ZE_API
int amath_asin(void *ptr);

ZE_API
int amath_sinh(void *ptr);

ZE_API
int amath_tan(void *ptr);

ZE_API
int amath_atan(void *ptr);

ZE_API
int amath_tanh(void *ptr);

ZE_API
int amath_sqrt(void *ptr);

ZE_API
int amath_exp(void *ptr);

ZE_API
int amath_log(void *ptr);

ZE_API
int amath_log10(void *ptr);

ZE_API
int amath_ceil(void *ptr);

ZE_API
int amath_floor(void *ptr);

ZE_API
int amath_abs(void *ptr);

ZE_API
int amath_mod(void *ptr, double v);

ZE_API
int amath_mod_ex(void *ptr, double v);

ZE_API
int amath_mod2(void *ptr, const void *div);

ZE_API
int amath_pow(void *ptr, double v);

ZE_API
int amath_pow_ex(void *ptr, double v);

ZE_API
int amath_pow2(void *ptr, const void *div);

ZE_API
int amath_rand(void *ptr, long seed = 10);

ZE_API
int amath_make_identity(void *ptr, size_t n);

ZE_API
int amath_make_rotatex(void *ptr, double deg);

ZE_API
int amath_make_rotatey(void *ptr, double deg);

ZE_API
int amath_make_rotatez(void *ptr, double deg);

ZE_API
int amath_make_scale(void *ptr, double sx, double sy, double sz);

ZE_API
int amath_make_translate(void *ptr, double dx, double dy, double dz);

ZE_API
int amath_make_p2p(void *ptr, double x1, double y1, double z1, double x2, double y2, double z2);


#ifdef __cplusplus
}
#endif

#endif
